/* Generator.h
 *
 *  Created on: 18 окт. 2016 г.
 *      Author: Roman Ryutin
 */

#ifndef GENERATOR_HH
#define GENERATOR_HH

#include <cmath>
#include <complex>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <map>
#include <string>
#include <utility>
#include <vector>
#include <cassert>
#include <time.h>
#include <ctime> 

#include "I.h"
#include "PI.h"
#include "NDarray.h"
#include "NDgrid.h"
#include "iFunc.h"
#include "newrand.h"

namespace ExDiff{ 

// multidimensional interpolating class of a data table
class Generator{
  public:
    explicit Generator (const iFunc&);
	explicit Generator (const iFunc&, const std::vector<iFunc>&, const double&);
	
//	Generator(){}
//	Generator(Generator& gen_){}
    virtual ~Generator(){}
	
	void printC();
	iFunc CalcMinus(const iFunc&);	
	std::vector<iFunc> CalcFUNG(const iFunc&); 
	std::vector<double> FGenVar(const std::vector<double>&, const std::vector<double>&);
	double GenVar(const std::vector<double>&, const std::vector<double>&, const double&);
	double GenVarFast1(const std::vector<double>&, const std::vector<double>&, const std::vector<double>&, const double&);
	double IntVec(const std::vector<double>&, const std::vector<double>&);
	std::vector<double> Generate();
	
	inline const double& GetFUNGTOT() const{
		return FUNGTOT;
	};
	inline double& GetFUNGTOT(){
		return FUNGTOT;
	};	
	
	inline const iFunc& GetFUN() const{
		return FUN;
	};
	inline iFunc& GetFUN(){
		return FUN;
	};	
	
	inline const std::vector<iFunc>& GetFUNG() const{
		return FUNG;
	};
	inline std::vector<iFunc>& GetFUNG(){
		return FUNG;
	};	
	
    double RNUM();

  private:
    iFunc FUN;
	std::vector<iFunc> FUNG;
	double FUNGTOT;
//		
	
}; // end of class Generator definitions

}// end of namespace ExDiff

#endif /* GENERATOR_HH */